﻿Namespace System.Collections.Generic
   Public Class TupleList(Of Ta, Tb, Tc, Td, Te, Tf) : Inherits List(Of Tuple(Of Ta, Tb, Tc, Td, Te, Tf))
      Public Overloads Function Add( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te,  f As Tf) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Add = tuple.Create(a, b, c, d, e, f)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function FindIndex( key As Tb) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
      End Function
      Public Overloads Function FindIndex( key As Tc) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
      End Function
      Public Overloads Function FindIndex( key As Td) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
      End Function
      Public Overloads Function FindIndex( key As Te) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item5))
      End Function
      Public Overloads Function FindIndex( key As Tf) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item6))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tb) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tc) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Td) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Te) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tf) As Tuple(Of Ta, Tb, Tc, Td, Te, Tf)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of Ta, Tb, Tc, Td, Te, Tf, TResult)) As List(Of TResult)
         Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6)).ToList
      End Function
      Public Overloads Sub ForEach( action As Action(Of Ta, Tb, Tc, Td, Te, Tf))
         ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5, tpl.Item6))
      End Sub
   End Class
   Public Class TupleList(Of Ta, Tb, Tc, Td, Te) : Inherits List(Of Tuple(Of Ta, Tb, Tc, Td, Te))
      Public Overloads Function Add( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Add = tuple.Create(a, b, c, d, e)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function FindIndex( key As Tb) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
      End Function
      Public Overloads Function FindIndex( key As Tc) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
      End Function
      Public Overloads Function FindIndex( key As Td) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
      End Function
      Public Overloads Function FindIndex( key As Te) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item5))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tb) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tc) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Td) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Te) As Tuple(Of Ta, Tb, Tc, Td, Te)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of Ta, Tb, Tc, Td, Te, TResult)) As List(Of TResult)
         Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5)).ToList
      End Function
      Public Overloads Sub ForEach( action As Action(Of Ta, Tb, Tc, Td, Te))
         ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4, tpl.Item5))
      End Sub
   End Class
   Public Class TupleList(Of Ta, Tb, Tc, Td) : Inherits List(Of Tuple(Of Ta, Tb, Tc, Td))
      Public Overloads Function Add( a As Ta,  b As Tb,  c As Tc,  d As Td) As Tuple(Of Ta, Tb, Tc, Td)
         Add = tuple.Create(a, b, c, d)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function FindIndex( key As Tb) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
      End Function
      Public Overloads Function FindIndex( key As Tc) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
      End Function
      Public Overloads Function FindIndex( key As Td) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item4))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta, Tb, Tc, Td)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tb) As Tuple(Of Ta, Tb, Tc, Td)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tc) As Tuple(Of Ta, Tb, Tc, Td)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Td) As Tuple(Of Ta, Tb, Tc, Td)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of Ta, Tb, Tc, Td, TResult)) As List(Of TResult)
         Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4)).ToList
      End Function
      Public Overloads Sub ForEach( action As Action(Of Ta, Tb, Tc, Td))
         ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3, tpl.Item4))
      End Sub
   End Class
   Public Class TupleList(Of Ta, Tb, Tc) : Inherits List(Of Tuple(Of Ta, Tb, Tc))
      Public Overloads Function Add( a As Ta,  b As Tb,  c As Tc) As Tuple(Of Ta, Tb, Tc)
         Add = tuple.Create(a, b, c)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function FindIndex( key As Tb) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
      End Function
      Public Overloads Function FindIndex( key As Tc) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item3))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta, Tb, Tc)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tb) As Tuple(Of Ta, Tb, Tc)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tc) As Tuple(Of Ta, Tb, Tc)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function ConvertAll(Of TResult)(converter As Func(Of Ta, Tb, Tc, TResult)) As List(Of TResult)
         Return Me.Select(Function(tpl) converter(tpl.Item1, tpl.Item2, tpl.Item3)).ToList
      End Function
      Public Overloads Sub ForEach( action As Action(Of Ta, Tb, Tc))
         ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2, tpl.Item3))
      End Sub
   End Class
   Public Class TupleList(Of Ta, Tb) : Inherits List(Of Tuple(Of Ta, Tb))
      Public Overloads Function Add( a As Ta,  b As Tb) As Tuple(Of Ta, Tb)
         Add = tuple.Create(a, b)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function FindIndex( key As Tb) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item2))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta, Tb)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function Find( key As Tb) As Tuple(Of Ta, Tb)
         Return Me(FindIndex(key))
      End Function
      Public Overloads Function ConvertAll(Of TResult)( conversion As Func(Of Ta, Tb, TResult)) As List(Of TResult)
         ConvertAll = New List(Of TResult)(Me.Count)
         ForEach(Sub(tpl) ConvertAll.Add(conversion(tpl.Item1, tpl.Item2)))
      End Function
      Public Overloads Sub ForEach( action As Action(Of Ta, Tb))
         ForEach(Sub(tpl) action(tpl.Item1, tpl.Item2))
      End Sub
   End Class
   Public Class TupleList(Of Ta) : Inherits List(Of Tuple(Of Ta))
      Public Overloads Function Add( a As Ta) As Tuple(Of Ta)
         Add = tuple.Create(a)
         MyBase.Add(Add)
      End Function
      Public Overloads Function FindIndex( key As Ta) As Integer
         Return MyBase.FindIndex(Function(tpl) Object.Equals(key, tpl.Item1))
      End Function
      Public Overloads Function Find( key As Ta) As Tuple(Of Ta)
         Return Me(FindIndex(key))
      End Function
   End Class

   Public Class TupleList
      Public Shared Function From(Of Ta, Tb, Tc, Td, Te, Tf)( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te,  f As Tf) As TupleListIniter(Of Ta, Tb, Tc, Td, Te, Tf)
         Return (New TupleListIniter(Of Ta, Tb, Tc, Td, Te, Tf))(a, b, c, d, e, f)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc, Td, Te)( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te) As TupleListIniter(Of Ta, Tb, Tc, Td, Te)
         Return (New TupleListIniter(Of Ta, Tb, Tc, Td, Te))(a, b, c, d, e)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc, Td)( a As Ta,  b As Tb,  c As Tc,  d As Td) As TupleListIniter(Of Ta, Tb, Tc, Td)
         Return (New TupleListIniter(Of Ta, Tb, Tc, Td))(a, b, c, d)
      End Function
      Public Shared Function From(Of Ta, Tb, Tc)( a As Ta,  b As Tb,  c As Tc) As TupleListIniter(Of Ta, Tb, Tc)
         Return (New TupleListIniter(Of Ta, Tb, Tc))(a, b, c)
      End Function
      Public Shared Function From(Of Ta, Tb)( a As Ta,  b As Tb) As TupleListIniter(Of Ta, Tb)
         Return (New TupleListIniter(Of Ta, Tb))(a, b)
      End Function
      Public Shared Function From(Of Ta)( a As Ta) As TupleListIniter(Of Ta)
         Return (New TupleListIniter(Of Ta))(a)
      End Function
   End Class

   Public Class TupleListIniter(Of Ta, Tb, Tc, Td, Te, Tf) : Inherits TupleList(Of Ta, Tb, Tc, Td, Te, Tf)
      Default Public Shadows ReadOnly Property Adding( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te,  f As Tf) As TupleListIniter(Of Ta, Tb, Tc, Td, Te, Tf)
         Get
            MyBase.Add(tuple.Create(a, b, c, d, e, f))
            Return Me
         End Get
      End Property
   End Class
   Public Class TupleListIniter(Of Ta, Tb, Tc, Td, Te) : Inherits TupleList(Of Ta, Tb, Tc, Td, Te)
      Default Public Shadows ReadOnly Property Adding( a As Ta,  b As Tb,  c As Tc,  d As Td,  e As Te) As TupleListIniter(Of Ta, Tb, Tc, Td, Te)
         Get
            MyBase.Add(tuple.Create(a, b, c, d, e))
            Return Me
         End Get
      End Property
   End Class
   Public Class TupleListIniter(Of Ta, Tb, Tc, Td) : Inherits TupleList(Of Ta, Tb, Tc, Td)
      Default Public Shadows ReadOnly Property Adding( a As Ta,  b As Tb,  c As Tc,  d As Td) As TupleListIniter(Of Ta, Tb, Tc, Td)
         Get
            MyBase.Add(tuple.Create(a, b, c, d))
            Return Me
         End Get
      End Property
   End Class
   Public Class TupleListIniter(Of Ta, Tb, Tc) : Inherits TupleList(Of Ta, Tb, Tc)
      Default Public Shadows ReadOnly Property Adding( a As Ta,  b As Tb,  c As Tc) As TupleListIniter(Of Ta, Tb, Tc)
         Get
            MyBase.Add(tuple.Create(a, b, c))
            Return Me
         End Get
      End Property
   End Class
   Public Class TupleListIniter(Of Ta, Tb) : Inherits TupleList(Of Ta, Tb)
      Default Public Shadows ReadOnly Property Adding( a As Ta,  b As Tb) As TupleListIniter(Of Ta, Tb)
         Get
            MyBase.Add(tuple.Create(a, b))
            Return Me
         End Get
      End Property
   End Class
   Public Class TupleListIniter(Of Ta) : Inherits TupleList(Of Ta)
      Default Public Shadows ReadOnly Property Adding( a As Ta) As TupleListIniter(Of Ta)
         Get
            MyBase.Add(tuple.Create(a))
            Return Me
         End Get
      End Property
   End Class

End Namespace